## odc 1.2.0

=== CMakeLists.txt ===
# (C) Copyright 2011- ECMWF.
#
# This software is licensed under the terms of the Apache Licence Version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation nor
# does it submit to any jurisdiction.

########################################################################################################################

cmake_minimum_required( VERSION 3.12 FATAL_ERROR )

find_package( ecbuild 3.4 REQUIRED HINTS ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/../ecbuild)

project( odc LANGUAGES C CXX )

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

########################################################################################################################
### dependencies and options

ecbuild_find_package( NAME eckit VERSION 1.4 REQUIRED )

#ecbuild_add_option( FEATURE NETCDF
#                    DESCRIPTION "whether or not to build the odb2netcdf tool"
#                    DEFAULT OFF
#                    REQUIRED_PACKAGES "NetCDF COMPONENTS CXX" )

ecbuild_add_option( FEATURE FORTRAN
                    DESCRIPTION "whether or not to build the Fortran interface"
                    DEFAULT OFF )

if( HAVE_FORTRAN )
    ecbuild_enable_fortran( REQUIRED MODULE_DIRECTORY ${PROJECT_BINARY_DIR}/module )
endif()

########################################################################################################################
# contents

add_subdirectory( src )
add_subdirectory( regressions )
add_subdirectory( tests )

############################################################################################
# finalize

ecbuild_pkgconfig( NAME ${PROJECT_NAME}
                   DESCRIPTION "ECMWF encoding and decoding of observational data in ODB2 format"
                   URL "https://software.ecmwf.int/wiki/display/ODC"
                   LIBRARIES odccore )

ecbuild_install_project( NAME odc )

ecbuild_print_summary()

=== regressions/CMakeLists.txt ===

list( APPEND regressions_data_files
    2000010106.odb
    odb_387_mdset.odb
    odb_463.odb
)

ecbuild_get_test_multidata( TARGET odc_get_regressions_data
                            #DIRNAME odc/tests
                            NAMES ${regressions_data_files}
                            NOCHECK )

set(regressions_scripts

    ODB-374.sh
    ODB-387-and-388.sh
    ODB-463.sh
)

foreach( _script ${regressions_scripts})
    ecbuild_add_test(
        TYPE script
        COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/${_script}
        ENVIRONMENT PATH=${CMAKE_BINARY_DIR}/bin:$ENV{PATH}
        TEST_DEPENDS odc_get_regressions_data
    )
endforeach()


# Add a custom target to make these files visible in qtcreator

add_custom_target(
    regressions_file_visibility
    SOURCES ${regressions_scripts}
)

=== src/CMakeLists.txt ===
## check if all sources are used
ecbuild_find_project_files()

### config header

ecbuild_generate_config_headers( DESTINATION ${INSTALL_INCLUDE_DIR}/odc )

configure_file( odc_config.h.in odc_config.h )

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/odc_config.h DESTINATION ${INSTALL_INCLUDE_DIR}/odc )

### libs

add_subdirectory( odc )
add_subdirectory( odc/tools )
add_subdirectory( odc/odb2netcdf )

### fortran bindings -- OFF for the moment due to errors with gfortran 6.3 / 7.3
add_subdirectory( fortran )

=== tests/CMakeLists.txt ===
### test data files


list( APPEND test_data_files
2000010106.odb.gz
2000010106.odb
2000010106.1.0.odb
2000010106.2.0.odb
2000010106.3.0.odb
2000010106.4.0.odb
2000010106.5.0.odb
2000010106.6.0.odb
2000010106.7.0.odb
2000010106.7.1.odb
2000010106.7.2.odb
2000010106.7.3.odb
mondb.1.12.odb
TestIntegerValues.odb
split_crash_on_andate_and_antime.odb
TestMetaDataReader.odb
a1to10twice.odb
TestAggregateFunctions2.odb
dribu.odb
TestAggregateFunctions3.odb

# MetOffice schema for testing ODB-127
ECMA.ddl
ECMATMP.ddl
cma.hh
bitfields.hh
group_id.hh
mdi.hh
ops_obsgroups.hh
ops_subtypes.hh
report_types.hh
sensor.hh
varno.hh
vertco_type.hh
)

ecbuild_get_test_multidata( TARGET odc_get_test_data
                            #DIRNAME odc/tests
                            NAMES ${test_data_files}
                            NOCHECK )

### list tests

list( APPEND odc_tests
Test_AggregateFunctions
Test_AggregateFunctions2
Test_AggregateFunctions3
Test_AtTableInTheOutput
Test_Bitfields
Test_CREATE_TABLE_and_SELECT_INTO
Test_ChildTable_DataLoaderReturnsExpectedChildTableRows
Test_ChildTable_DataLoaderReturnsExpectedNumberOfChildTableColumns
Test_ChildTable_DataLoaderReturnsExpectedNumberOfChildTableRows
Test_CommandLineParsing
Test_DataRowCanSetDoubles
Test_DataRowCanSetIntegers
Test_DataRowCanSetStrings
Test_DataRowInitializedFromColumnsHasExpectedFlags
Test_DataRowInitializedFromColumnsHasExpectedSize
Test_DataRowInitializedFromColumnsHasExpectedValues
Test_DispatchingWriter
Test_Distinct
Test_EmptyPageWithFillMark_PushBackRowsToEmptyPageWithFillMark
Test_EmptyPageWithFillMark_ResizeEmptyPageWithFillMark
Test_EmptyPage_CanIncreasePageSizeAndInitializeValues
Test_EmptyPage_CannotIncreasePageSizeBeyondItsCapacity
Test_EmptyPage_DecreadingSizeOfEmptyPageToZero
Test_EmptyPage_EmptyPageCanBeCleared
Test_EmptyPage_EmptyPageHasZeroSize
Test_EmptyPage_EmptyPageIsEmpty
Test_EmptyPage_EmptyPageIsNotFull
Test_EmptyPage_HasTheCorrectCapacity
Test_EmptyPage_IncreadingSizeOfEmptyPageToHalfTheCapacity
Test_EmptyPage_IteratorReturnsExpectedNumberOfRows
Test_EmptyPage_PushingBackRowsToAnEmptyPage
Test_EmptyTable_CanBeCleared
Test_EmptyTable_CapacityCanBeIncreased
Test_EmptyTable_HasExpectedCapacity
Test_EmptyTable_HasZeroSize
Test_EmptyTable_IsEmpty
Test_EmptyTable_SizeCanBeIncreased
Test_FilledDataSet_DataLoaderReturnsExpectedNumberOfTables
Test_FilledDataSet_DataLoaderReturnsExpectedTables
Test_FilledDataSet_DataSaverOutputContainsExpectedRows
Test_FilledLink_DataLinkHasExpectedSize
Test_FilledLink_DataLinkIteratorReturnsExpectedNumberOfChildRows
Test_FilledLink_DataLinkIteratorReturnsExpectedNumberOfParentRows
Test_FilledLink_DataLinkIteratorReturnsExpectedRows
Test_FilledLink_DataLinkReturnsExpectedChildTable
Test_FilledLink_DataLinkReturnsExpectedParentTable
Test_FilledLink_InsertRowAtTheBeginningOfTheFirstRange
Test_FilledLink_InsertRowAtTheEndOfTheLastRange
Test_FilledTable_AdvanceIteratorBackward
Test_FilledTable_AdvanceIteratorByHalf
Test_FilledTable_AdvanceIteratorByZero
Test_FilledTable_AdvanceIteratorForewardByOne
Test_FilledTable_AdvanceIteratorToTheEnd
Test_FilledTable_CanBeCleared
Test_FilledTable_CanIterateBackward
Test_FilledTable_CanIterateForeward
Test_FilledTable_CapacityCanBeIncreased
Test_FilledTable_DistanceBetweenBeginAndEndIteratorIsAsExpected
Test_FilledTable_DistanceBetweenTheSameIteratorsIsZero
Test_FilledTable_GetRowAtTheBack
Test_FilledTable_HasExpectedCapacity
Test_FilledTable_HasExpectedNonZeroSize
Test_FilledTable_InsertRowAtTheBeginning
Test_FilledTable_InsertRowAtTheEnd
Test_FilledTable_IsNotEmpty
Test_FilledTable_SizeCanBeDecreased
Test_FilledTable_SizeCanBeIncreased
Test_Fixture_DataLoaderWithTableMappings
Test_Fixture_InsertingTablesIncreasesSize
Test_Fixture_LoadDataSetFromSqlQueries
Test_FullPage_CanDecreasePageSize
Test_FullPage_CanNotInsertRowToAFullPage
Test_FullPage_DecreadingSizeOfFullPageByHalf
Test_FullPage_DecreadingSizeOfFullPageToZero
Test_FullPage_DecreasingSizeOfFullPageToHalfTheCapacity
Test_FullPage_FullPageCanBeCleared
Test_FullPage_FullPageHasSizeOfItsCapacity
Test_FullPage_FullPageIsFull
Test_FullPage_FullPageIsNotEmpty
Test_FullPage_IncreadingSizeOfFullPageBeyondItsCapacity
Test_FullPage_IteratorReturnsExpectedNumberOfRows
Test_FullPage_IteratorReturnsExpectedRows
Test_FullPage_PushingBackRowsToTheFullPage
Test_FullPage_SplitFullPage
Test_FunctionDateAndTime
Test_FunctionTdiff
Test_FunctionThin
Test_FunctionTypeConversion
Test_FunctionsForAngleConversion
Test_FunctionsForTemperatureConversion
Test_HalfEmptyPage_InsertRowAtTheBeginning
Test_HalfEmptyPage_InsertRowAtTheEnd
Test_HashTable_clone
Test_InitializedDataRowHasExpectedFlags
Test_InitializedDataRowHasExpectedSize
Test_InitializedDataRowHasExpectedValues
Test_InnerJoin_InnerJoinHasExpectedColumns
Test_InnerJoin_InnerJoinHasExpectedNumberOfColumns
Test_InnerJoin_InnerJoinReturnsExpectedNumberOfResults
Test_InnerJoin_InnerJoinReturnsExpectedValues
Test_Int16_MissingCodec
Test_IntegerValues
Test_JULIAN_SECONDS
Test_LinkedTables_DataJoinCanBeUsedWithStlAlgorithms
Test_LinkedTables_DataJoinHasExpectedColumns
Test_LinkedTables_DataJoinHasExpectedNumberOfColumns
Test_LinkedTables_DataJoinReturnsExpectedNumberOfResults
Test_LinkedTables_DataJoinReturnsExpectedValues
Test_MetaData
Test_MissingValue
Test_OrderBy
Test_Ordinals_CopiedDataRowHasExpectedFlags
Test_Ordinals_CopiedDataRowHasExpectedValues
Test_Ordinals_DataRowCopyHasExpectedFlags
Test_Ordinals_DataRowCopyHasExpectedSize
Test_Ordinals_DataRowCopyHasExpectedValues
Test_ParentTable_DataLoaderReturnsExpectedNumberOfParentTableColumns
Test_ParentTable_DataLoaderReturnsExpectedNumberOfParentTableRows
Test_ParentTable_DataLoaderReturnsExpectedParentTableRows
Test_SelectAggregate_ReturnsExpectedColumns
Test_SelectAggregate_ReturnsExpectedNumberOfColumns
Test_SelectAggregate_ReturnsExpectedNumberOfResults
Test_SelectAggregate_ReturnsExpectedResults
Test_SelectAll_CanUseCopyToAppendResults
Test_SelectAll_ReturnsExpectedColumns
Test_SelectAll_ReturnsExpectedNumberOfColumns
Test_SelectAll_ReturnsExpectedNumberOfResults
Test_SelectAll_ReturnsExpectedResults
Test_SelectDataHandle
Test_SelectStarAt
Test_SelectTwoFiles
Test_SelectWhere_ReturnsExpectedColumns
Test_SelectWhere_ReturnsExpectedNumberOfColumns
Test_SelectWhere_ReturnsExpectedNumberOfResults
Test_SelectWhere_ReturnsExpectedResults
Test_Setvbuffer
Test_Star
Test_TextReaderIterator_parseBitfields
Test_TextReaderIterator_parseBitfields_32bits_limit
Test_ThreeColumnTable_LineByLineInitialization
Test_ThreeColumnTable_MultiLineInitialization
Test_UnInitializedDataRowHasExpectedFlags
Test_UnInitializedDataRowHasExpectedSize
Test_bitfieldsLength
Test_bitfields_hash_operator
Test_blocksSizes
Test_dateTime
Test_hash_operator_in_where
Test_hash_operator_on_select_list
Test_include
Test_log_error
Test_meta_data_reader_checks_if_file_truncated
Test_meta_data_reader_fails_scanning_corrupted_file
Test_operator_ge
Test_rownumber1
Test_selectAggregatedAndNonAggregated
Test_selectAggregatedAndNonAggregated2
Test_selectAggregatedAndNonAggregated3
Test_selectAggregatedAndNonAggregatedNULL
Test_select_constant_value
Test_sqlOutputFormatting
Test_stringInWhere
Test_windSpeedWindDirection
Test_IndexTool
Test_BufferedHandle_ODB80
Test_QuestionMarkHandlingWhenSplittingByStringColumn_ODB235

#Examples.cc
Test_example_select_data_read_results
Test_example_read_data
Test_example_write_data
Test_example_sql_select_callback
Test_example_sql_select_callback_invoked_as_a_request
Test_example_sql_select_and_a_mars_verb_as_a_callback

#CAPIExamples.cc
Test_c_api_example_select_data_read_results
Test_c_api_example_read_data
Test_c_api_example_write_data
)


set( test_environment
  odc_CODES=${PROJECT_SOURCE_DIR}/etc
  odc_HOME=${PROJECT_SOURCE_DIR}
  odc_TEST_DATA_PATH=${CMAKE_CURRENT_BINARY_DIR}
  PATH=${CMAKE_BINARY_DIR}/bin:$ENV{PATH}
  ODB_RTABLE_PATH=${PROJECT_SOURCE_DIR}/etc

  TEST_DHSHOME=${CMAKE_CURRENT_BINARY_DIR}/dhshome/
  TEST_DATA_DIRECTORY=${CMAKE_CURRENT_BINARY_DIR}
  )

### odb2netcdf tests

ecbuild_get_test_multidata(
    TARGET odc_get_odb2netcdf_data
    NAMES odb2netcdf_1d.odb odb2netcdf_1d.cdl
          odb2netcdf_2d_hdr.odb odb2netcdf_2d_body.odb odb2netcdf_2d.cdl
    NOCHECK )

ecbuild_add_test( TARGET test_odb2netcdf_1d
    COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/test_odb2netcdf_1d.sh
    ENVIRONMENT ${test_environment}
    LABELS       odc odc_netcdf
    TEST_DEPENDS get_odb2netcdf_data
    CONDITION HAVE_NETCDF )

ecbuild_add_test( TARGET test_odb2netcdf_2d
    COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/test_odb2netcdf_2d.sh
    ENVIRONMENT ${test_environment}
    TEST_DEPENDS get_odb2netcdf_data
    LABELS       odc odc_netcdf
    CONDITION HAVE_NETCDF )

### odc tests

set( _prev_test odc_get_test_data  )

foreach( _test ${odc_tests} )
    set( _dependencies ${_prev_test} )
    ecbuild_add_test( TARGET       ${_test}
                      COMMAND      $<TARGET_FILE:odc>
                      ARGS         ${_test}
                      ENVIRONMENT  ${test_environment}
                      LABELS       odc
                      TEST_DEPENDS ${_dependencies})
    set( _prev_test ${_test} )
endforeach()

# n.b. Old behaviour (c.f. ODB-394) re-enabled with ODB_PATCH_TIME_ENCODE_RELATIVE.
# This is a bit of a hack...

ecbuild_get_test_multidata( TARGET  odc_get_mars_client_test_data_mo
                            DIRNAME odc/tests
                            NAMES   20150218_glu_surface_odb2 )

ecbuild_get_test_multidata( TARGET  odc_get_mars_client_test_data_ec
                            DIRNAME odc/tests
                            NAMES   conv_mfb_20151108_12.odb )

ecbuild_add_executable( TARGET      test_client_lib_fortran
                        CONDITION   HAVE_FORTRAN AND HAVE_ODB
                        SOURCES     test_client_lib_fortran.f90
                        LIBS        odc_fortran
                        LINKER_LANGUAGE Fortran)

ecbuild_add_executable( TARGET      test_client_lib_cpp
                        CONDITION   HAVE_ODB
                        SOURCES     test_client_lib_cpp.cc
                        LIBS        odccore odctools )

include_directories( ${CMAKE_CURRENT_SOURCE_DIR} )

add_subdirectory( core )
add_subdirectory( sql )
add_subdirectory( tools )
add_subdirectory( server )
add_subdirectory( api )
add_subdirectory( c_api )
add_subdirectory( f_api )

=== src/fortran/CMakeLists.txt ===

ecbuild_add_library(TARGET		odc_fortran

                    CONDITION   HAVE_FORTRAN

                    SOURCES
                                # Legacy:

                                odc_c_binding.f90

                    PUBLIC_LIBS odccore

                    PUBLIC_INCLUDES $<BUILD_INTERFACE:${CMAKE_Fortran_MODULE_DIRECTORY}> )

set( test_environment_fortran
     TEST_DHSHOME=${PROJECT_SOURCE_DIR}/tests/dhshome/
)

if( HAVE_FORTRAN )

    list( APPEND fortran_tests

        # Legacy API examples
        legacy_fortran_api_examples
        legacy_test_fortran_api_open_non_existing_file
    )

    foreach( _test ${fortran_tests} )
        ecbuild_add_test( TARGET     odc_${_test}
                          CONDITION  HAVE_FORTRAN
                          SOURCES    ${_test}.f90
                          LIBS       odc_fortran 
                          ENVIRONMENT  ${test_environment_fortran}

                          LABELS     odc odc_fortran

                          TEST_DEPENDS odc_get_test_data
                                       odc_get_mars_client_test_data_mo
                                       odc_get_mars_client_test_data_ec

                          LINKER_LANGUAGE Fortran )
    endforeach()

# Legacy Fortran bindings:
    install( FILES ${CMAKE_Fortran_MODULE_DIRECTORY}/${CMAKE_CFG_INTDIR}/odc_c_binding.mod DESTINATION ${INSTALL_INCLUDE_DIR} )
endif()

=== src/odc/CMakeLists.txt ===
configure_file( ODBAPIVersionSHA1.cc.in ODBAPIVersionSHA1.cc @ONLY )

configure_file( odc_config.f90.in odc_config.f90 )


list( APPEND odclib_src_files

api/odc.h
api/odc.cc
api/Odb.h
api/Odb.cc
api/ColumnType.h
api/ColumnInfo.h
api/StridedData.h

pyodbapi.h
ODBAPIVersionSHA1.cc
StringTool.cc
StringTool.h
CommandLineParser.cc
CommandLineParser.h
Comparator.cc
Comparator.h
ConstantSetter.cc
ConstantSetter.h
DispatchingWriter.cc
DispatchingWriter.h
MDI.cc
MDI.h
IteratorProxy.h
LibOdc.cc
LibOdc.h
MDSetter.cc
MDSetter.h
MDUpdatingIterator.cc
MDUpdatingIterator.h
ODAHandle.cc
ODAHandle.h
ODATranslator.h
ODAUpdatingIterator.cc
ODAUpdatingIterator.h
ODBAPISettings.cc
ODBAPISettings.h
ODBAPIVersion.cc
ODBAPIVersion.h
ODBApplication.cc
ODBApplication.h
Select.cc
Select.h
Reader.cc
Reader.h
ReaderIterator.cc
ReaderIterator.h
SelectIterator.cc
SelectIterator.h
TemplateParameters.cc
TemplateParameters.h
Writer.cc
Writer.h
WriterBufferingIterator.cc
WriterBufferingIterator.h
WriterDispatchingIterator.cc
WriterDispatchingIterator.h
odccapi.cc
odccapi.h
RowsCounter.h
RowsCounter.cc
Block.h
Block.cc
Indexer.h
Indexer.cc
RequestUtils.h
RequestUtils.cc
ODBTarget.cc
ODBTarget.h

core/Column.cc
core/Column.h
core/DataStream.h
core/DecodeTarget.cc
core/DecodeTarget.h
core/Encoder.cc
core/Encoder.h
core/Exceptions.cc
core/Exceptions.h
core/Header.cc
core/Header.h
core/MetaData.cc
core/MetaData.h
core/Span.cc
core/Span.h
core/Table.cc
core/Table.h
core/TablesReader.cc
core/TablesReader.h
core/ThreadSharedDataHandle.cc
core/ThreadSharedDataHandle.h
core/Codec.cc
core/Codec.h
core/CodecFactory.h
core/CodecFactory.cc

codec/Constant.cc
codec/Constant.h
codec/Integer.cc
codec/Integer.h
codec/IntegerMissing.cc
codec/IntegerMissing.h
codec/String.cc
codec/String.h
codec/Real.cc
codec/Real.h
codec/CodecOptimizer.cc
codec/CodecOptimizer.h

csv/TextReader.cc
csv/TextReader.h
csv/TextReaderIterator.cc
csv/TextReaderIterator.h

sql/SQLOutputConfig.cc
sql/SQLOutputConfig.h
sql/SQLSelectOutput.cc
sql/SQLSelectOutput.h
sql/ODAOutput.cc
sql/ODAOutput.h
sql/TODATable.cc
sql/TODATable.h
sql/TODATableIterator.cc
sql/TODATableIterator.h
sql/Types.cc
sql/Types.h
sql/function/FunctionEQ_BOXLAT.cc
sql/function/FunctionEQ_BOXLAT.h
sql/function/FunctionEQ_BOXLON.cc
sql/function/FunctionEQ_BOXLON.h
sql/function/FunctionRGG_BOXLAT.cc
sql/function/FunctionRGG_BOXLAT.h
sql/function/FunctionRGG_BOXLON.cc
sql/function/FunctionRGG_BOXLON.h
sql/function/EqRegionCache.cc
sql/function/EqRegionCache.h
sql/function/RegionCache.cc
sql/function/RegionCache.h
sql/function/RggRegionCache.cc
sql/function/RggRegionCache.h
sql/function/piconst.h

utility/Tracer.cc
utility/Tracer.h

# Data types' support
data/DataHandleFactory.h
data/DataHandleFactory.cc
data/FileHandleFactory.h
data/FileHandleFactory.cc
data/PartFileHandleFactory.h
data/PartFileHandleFactory.cc
data/HttpHandle.h
data/HttpHandle.cc
data/HttpHandleFactory.h
data/HttpHandleFactory.cc

#iterator-api/BaseReader.cc
#iterator-api/BaseReader.h
)

# templates

list( APPEND odclib_templates
ConstantSetter.cc
ODAUpdatingIterator.cc
WriterDispatchingIterator.cc
MDUpdatingIterator.cc
)

# define odc library

ecbuild_add_library( TARGET odccore
                     INSTALL_HEADERS
                        LISTED
                     HEADER_DESTINATION
                        ${INSTALL_INCLUDE_DIR}/odc
                     SOURCES
                        ${odclib_src_files}
                     GENERATED
                        ODBAPIVersionSHA1.cc
                     TEMPLATES
                        ${odclib_templates}
                     PUBLIC_INCLUDES
                        $<BUILD_INTERFACE:${PROJECT_BINARY_DIR}/src>
                        $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/src>
                     PUBLIC_LIBS
                        eckit_sql eckit )

ecbuild_add_library(
    TARGET          fodc
    CONDITION       HAVE_FORTRAN
    SOURCES         api/odc.f90
                    odc_config.f90
    GENERATED       odc_config.f90
    PUBLIC_INCLUDES $<BUILD_INTERFACE:${PROJECT_BINARY_DIR}/module>
    PUBLIC_LIBS     odccore
)

=== tests/api/CMakeLists.txt ===

list( APPEND _api_odc_tests
    read
    import
)

foreach( _test ${_api_odc_tests} )
    ecbuild_add_test(
        TARGET       odc_api_${_test}
        SOURCES      ${_test}.cc
        ENVIRONMENT  ${test_environment}
        TEST_DEPENDS odc_get_test_data
        LIBS         eckit odccore )
endforeach()

=== tests/c_api/CMakeLists.txt ===

list( APPEND _api_odc_tests
    read
    encode
    errors
)

foreach( _test ${_api_odc_tests} )
    ecbuild_add_test(
        TARGET       odc_capi_${_test}
        SOURCES      ${_test}.cc
        ENVIRONMENT  ${test_environment}
        TEST_DEPENDS odc_get_test_data
        LIBS         eckit odccore )
endforeach()

=== tests/core/CMakeLists.txt ===

list( APPEND _core_odc_tests
    test_encode_odb
    test_decode_odb
    test_codecs_write
    test_codecs_read
    test_codecs_end_to_end
    test_codecs_end_to_end2
    test_reencode_string_table
    test_concatenated_odbs
    test_minmax
    test_metadata

    test_select_iterator
    test_text_reader
    test_table_iterator
    test_table
)

foreach( _test ${_core_odc_tests} )
    ecbuild_add_test(
        TARGET       odc_${_test}
        SOURCES      ${_test}.cc ../TemporaryFiles.h
        TEST_DEPENDS odc_get_test_data
        ENVIRONMENT  ${test_environment}
        LIBS         eckit odccore )
endforeach()

=== tests/f_api/CMakeLists.txt ===

list( APPEND _api_fodc_tests
    general
    read
    encode
)

foreach( _test ${_api_fodc_tests} )
    ecbuild_add_test(
        TARGET       odc_fapi_${_test}
        SOURCES      ${_test}.f90
        ENVIRONMENT  ${test_environment}
        TEST_DEPENDS odc_get_test_data
        CONDITION    HAVE_FORTRAN
        LIBS         fodc )
endforeach()

ecbuild_add_executable( TARGET     odc-fortran-ls
                        SOURCES    odc_ls.f90
                        LIBS       fodc
                        CONDITION    HAVE_FORTRAN
                        NOINSTALL)

=== tests/server/CMakeLists.txt ===

#list( APPEND _odc_server_tests
#    test_partition )

foreach( _test ${_odc_server_tests} )
    ecbuild_add_test(
        TARGET       odc_${_test}
        SOURCES      ${_test}.cc
        TEST_DEPENDS odc_get_test_data
        ENVIRONMENT  ${test_environment}
        LIBS         eckit odccore
    )
endforeach()

=== tests/sql/CMakeLists.txt ===

list( APPEND _sql_odc_tests
    test_functions
    test_text_reader_select
    test_box_functions
)

foreach( _test ${_sql_odc_tests} )
    ecbuild_add_test(
        TARGET       odc_${_test}
        SOURCES      ${_test}.cc ../TemporaryFiles.h
        ENVIRONMENT  ${test_environment}
        TEST_DEPENDS odc_get_test_data
        LIBS         eckit odccore )
endforeach()



# TODO: Pure tests for the pure-sql stuff. The functions clearly invoke odc-specific behaviour

=== debian/changelog ===
odc (1.2.0-1) unstable; urgency=medium

  * New upstream release
  * Add debian/watch file
  * Standards-Version: 4.5.1

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 21 Jan 2021 13:18:35 +0000

odc (1.1.0-2) unstable; urgency=medium

  * Append $(FC) to libfodc for fortran versioning
  * Fix CMake fragments

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 04 Nov 2020 14:01:28 +0000

odc (1.1.0-1) unstable; urgency=medium

  * Initial release. (Closes: #973615)

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 02 Nov 2020 17:00:09 +0000

=== debian/control ===
Source: odc
Section: utils
Priority: optional
Maintainer: Alastair McKinstry <mckinstry@debian.org>
Build-Depends: debhelper-compat (=13),
 dh-sequence-fortran-mod,
 ecbuild (>= 3.3.0-3),
 gfortran | fortran-compiler, 
 libeckit-dev,
 patchelf
Standards-Version: 4.5.1
Homepage: https://github.com/ecmwf/odc
Vcs-Browser: https://salsa.debian.org:/science-team/odc.git
Vcs-Git: https://salsa.debian.org:/science-team/odc.git -b debian/latest

Package: libodc-0d
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Observational Database Access library for ECMWF
 ODC is software developed at ECMWF for encoding and processing of
 observational data. It includes a SQL filtering and statistics engine, 
 command line tools and APIs for C/C++ and Fortran.

Package: odc
Architecture: any
Multi-Arch: foreign
Depends: libodc-0d ( = ${binary:Version}), 
  ${shlibs:Depends}, ${misc:Depends}
Recommends: libodc-dev (= ${binary:Version})
Description: Tools for the Observational Data Processing (ODB) 
 ODC is software developed at ECMWF for encoding and processing o
 observational data. It includes a SQL filtering and statistics engine, 
 command line tools and APIs for C/C++ and Fortran.
 .
 This package provides tools for ODB handling.

Package: libodc-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libodc-0d (= ${binary:Version}), odc (= ${binary:Version}), 
  ${misc:Depends}, mpi-default-dev, libeckit-dev
Conflicts: libodb-dev
Recommends: pkg-config, fortran-compiler
Description: Observational Data processing for meteorology
 ODC is a software developed at ECMWF for encoding and processing of
 observational data. It includes a SQL filtering and statistics engine, 
 command line tools and APIs for C/C++, Fortran and Python.
 .
 This package provides shared libraries and headers.

=== debian/rules ===
#!/usr/bin/make -f

#export DH_VERBOSE=1

# FC set to f77 by default in make
# Read default compiler name unless FC is actually set
ifeq ($(FC),f77)
  FC:=$(shell basename $(shell readlink /etc/alternatives/f77))
endif

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
TMPDIR:=$(CURDIR)/debian/tmp
LIBDIR:=/usr/lib/$(DEB_HOST_MULTIARCH)

FORTRAN_VERSION:=$(shell basename $(shell readlink  /usr/bin/$(FC)))

# The magic debhelper  rule
%:
	dh $@ --buildsystem=ecbuild

BUILD_FLAGS:= -DENABLE_FORTRAN=ON \
			-DENABLE_RPATHS=OFF \

override_dh_auto_configure:
	dh_auto_configure -- \
		      ${BUILD_FLAGS} -DCMAKE_Fortran_COMPILER=$(FC)

override_dh_auto_test:
	@echo "Ignoring test failures in this build"
	# dh_auto_test ||  echo "Ignoring test failures" 

override_dh_dwz:
	@echo bypass dwz that causes build failures due to patchelf changes

override_dh_auto_install:
	dh_auto_install 
	mv $(TMPDIR)/$(LIBDIR)/libfodc.so.0d $(TMPDIR)/$(LIBDIR)/libfodc-$(FC).so.0d
	rm $(TMPDIR)/$(LIBDIR)/libfodc.so
	patchelf  --set-soname libfodc-$(FC).so.0d $(TMPDIR)/$(LIBDIR)/libfodc-$(FC).so.0d
	#patchelf  --remove-rpath $(TMPDIR)/$(LIBDIR)/libt-gfortran.so.0d
	dh_link -p libodc-dev $(LIBDIR)/libfodc-$(FC).so.0d $(LIBDIR)/fortran/$(FORTRAN_VERSION)/libfodc.so
	dh_link -p libodc-dev $(LIBDIR)/libfodc-$(FC).so.0d $(LIBDIR)/libfodc-$(FC).so
	# Fixup cmake files
	sed -i -e 's%$${_IMPORT_PREFIX}/include%/usr/include/${DEB_HOST_MULTIARCH}%g' $(TMPDIR)/$(LIBDIR)/cmake/odc/odc-targets.cmake
	sed -i -e 's%/include/odc%/usr/include/${DEB_HOST_MULTIARCH}/odc%g' $(TMPDIR)/$(LIBDIR)/cmake/odc/odc-targets.cmake
	sed -i -e 's%libfodc.so%libfodc-${FC}.so%g'   $(TMPDIR)/$(LIBDIR)/cmake/odc/odc-targets-release.cmake

## odc 1.3.0

=== regressions/CMakeLists.txt ===
--- 
+++ 
@@ -3,6 +3,9 @@
     2000010106.odb
     odb_387_mdset.odb
     odb_463.odb
+    sd_45315.odb
+    sd_45479_source.odb
+    sd_45479_compare.odb
 )
 
 ecbuild_get_test_multidata( TARGET odc_get_regressions_data
@@ -15,6 +18,8 @@
     ODB-374.sh
     ODB-387-and-388.sh
     ODB-463.sh
+    SD-45315.sh
+    SD-45479.sh
 )
 
 foreach( _script ${regressions_scripts})

=== tests/CMakeLists.txt ===
### test data files


list( APPEND test_data_files
2000010106.odb.gz
2000010106.odb
2000010106.1.0.odb
2000010106.2.0.odb
2000010106.3.0.odb
2000010106.4.0.odb
2000010106.5.0.odb
2000010106.6.0.odb
2000010106.7.0.odb
2000010106.7.1.odb
2000010106.7.2.odb
2000010106.7.3.odb
mondb.1.12.odb
TestIntegerValues.odb
split_crash_on_andate_and_antime.odb
TestMetaDataReader.odb
a1to10twice.odb
TestAggregateFunctions2.odb
dribu.odb
TestAggregateFunctions3.odb

# MetOffice schema for testing ODB-127
ECMA.ddl
ECMATMP.ddl
cma.hh
bitfields.hh
group_id.hh
mdi.hh
ops_obsgroups.hh
ops_subtypes.hh
report_types.hh
sensor.hh
varno.hh
vertco_type.hh
)

ecbuild_get_test_multidata( TARGET odc_get_test_data
                            #DIRNAME odc/tests
                            NAMES ${test_data_files}
                            NOCHECK )

### list tests

list( APPEND odc_tests
Test_AggregateFunctions
Test_AggregateFunctions2
Test_AggregateFunctions3
Test_AtTableInTheOutput
Test_Bitfields
Test_CREATE_TABLE_and_SELECT_INTO
Test_CommandLineParsing
Test_DispatchingWriter
Test_Distinct
Test_FunctionDateAndTime
Test_FunctionTdiff
Test_FunctionThin
Test_FunctionTypeConversion
Test_FunctionsForAngleConversion
Test_FunctionsForTemperatureConversion
Test_Int16_MissingCodec
Test_IntegerValues
Test_JULIAN_SECONDS
Test_MetaData
Test_MissingValue
Test_OrderBy
Test_SelectDataHandle
Test_SelectStarAt
Test_SelectTwoFiles
Test_Setvbuffer
Test_Star
Test_bitfieldsLength
Test_bitfields_hash_operator
Test_hash_operator_in_where
Test_hash_operator_on_select_list
Test_include
Test_log_error
Test_meta_data_reader_checks_if_file_truncated
Test_operator_ge
Test_rownumber1
Test_selectAggregatedAndNonAggregated
Test_selectAggregatedAndNonAggregated2
Test_selectAggregatedAndNonAggregated3
Test_selectAggregatedAndNonAggregatedNULL
Test_select_constant_value
Test_sqlOutputFormatting
Test_stringInWhere
Test_windSpeedWindDirection
#Test_CREATE_TABLE_and_SELECT_INTO
#Test_SELECT_WHERE_0
#Test_LegacyAPIExecuteSelectTwice
#Test_LegacyAPITraverseReaderTwice
Test_QuestionMarkHandlingWhenSplittingByStringColumn_ODB235

#Examples.cc
Test_example_select_data_read_results
Test_example_read_data
Test_example_write_data

#CAPIExamples.cc
Test_c_api_example_write_data
)


set( test_environment
  odc_CODES=${PROJECT_SOURCE_DIR}/etc
  odc_HOME=${PROJECT_SOURCE_DIR}
  odc_TEST_DATA_PATH=${CMAKE_CURRENT_BINARY_DIR}
  PATH=${CMAKE_BINARY_DIR}/bin:$ENV{PATH}

  TEST_DHSHOME=${CMAKE_CURRENT_BINARY_DIR}/dhshome/
  TEST_DATA_DIRECTORY=${CMAKE_CURRENT_BINARY_DIR}
  )

### odb2netcdf tests

ecbuild_get_test_multidata(
    TARGET odc_get_odb2netcdf_data
    NAMES odb2netcdf_1d.odb odb2netcdf_1d.cdl
          odb2netcdf_2d_hdr.odb odb2netcdf_2d_body.odb odb2netcdf_2d.cdl
    NOCHECK )

ecbuild_add_test( TARGET test_odb2netcdf_1d
    COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/test_odb2netcdf_1d.sh
    ENVIRONMENT ${test_environment}
    LABELS       odc odc_netcdf
    TEST_DEPENDS get_odb2netcdf_data
    CONDITION HAVE_NETCDF )

ecbuild_add_test( TARGET test_odb2netcdf_2d
    COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/test_odb2netcdf_2d.sh
    ENVIRONMENT ${test_environment}
    TEST_DEPENDS get_odb2netcdf_data
    LABELS       odc odc_netcdf
    CONDITION HAVE_NETCDF )

### odc tests

set( _prev_test odc_get_test_data  )

foreach( _test ${odc_tests} )
    set( _dependencies ${_prev_test} )
    ecbuild_add_test( TARGET       ${_test}
                      COMMAND      $<TARGET_FILE:odc>
                      ARGS         ${_test}
                      ENVIRONMENT  ${test_environment}
                      LABELS       odc
                      TEST_DEPENDS ${_dependencies})
    set( _prev_test ${_test} )
endforeach()

# n.b. Old behaviour (c.f. ODB-394) re-enabled with ODB_PATCH_TIME_ENCODE_RELATIVE.
# This is a bit of a hack...

ecbuild_get_test_multidata( TARGET  odc_get_mars_client_test_data_mo
                            DIRNAME odc/tests
                            NAMES   20150218_glu_surface_odb2 )

ecbuild_get_test_multidata( TARGET  odc_get_mars_client_test_data_ec
                            DIRNAME odc/tests
                            NAMES   conv_mfb_20151108_12.odb )

ecbuild_add_executable( TARGET      test_client_lib_fortran
                        CONDITION   HAVE_FORTRAN AND HAVE_ODB
                        SOURCES     test_client_lib_fortran.f90
                        LIBS        odc_fortran
                        LINKER_LANGUAGE Fortran)

ecbuild_add_executable( TARGET      test_client_lib_cpp
                        CONDITION   HAVE_ODB
                        SOURCES     test_client_lib_cpp.cc
                        LIBS        odccore odctools )

include_directories( ${CMAKE_CURRENT_SOURCE_DIR} )

add_subdirectory( core )
add_subdirectory( sql )
add_subdirectory( tools )
add_subdirectory( server )
add_subdirectory( api )
add_subdirectory( c_api )
add_subdirectory( f_api )

=== src/odc/CMakeLists.txt ===
--- 
+++ 
@@ -130,36 +130,9 @@
 sql/TODATableIterator.h
 sql/Types.cc
 sql/Types.h
-sql/function/FunctionEQ_BOXLAT.cc
-sql/function/FunctionEQ_BOXLAT.h
-sql/function/FunctionEQ_BOXLON.cc
-sql/function/FunctionEQ_BOXLON.h
-sql/function/FunctionRGG_BOXLAT.cc
-sql/function/FunctionRGG_BOXLAT.h
-sql/function/FunctionRGG_BOXLON.cc
-sql/function/FunctionRGG_BOXLON.h
-sql/function/EqRegionCache.cc
-sql/function/EqRegionCache.h
-sql/function/RegionCache.cc
-sql/function/RegionCache.h
-sql/function/RggRegionCache.cc
-sql/function/RggRegionCache.h
-sql/function/piconst.h
 
 utility/Tracer.cc
 utility/Tracer.h
-
-# Data types' support
-data/DataHandleFactory.h
-data/DataHandleFactory.cc
-data/FileHandleFactory.h
-data/FileHandleFactory.cc
-data/PartFileHandleFactory.h
-data/PartFileHandleFactory.cc
-data/HttpHandle.h
-data/HttpHandle.cc
-data/HttpHandleFactory.h
-data/HttpHandleFactory.cc
 
 #iterator-api/BaseReader.cc
 #iterator-api/BaseReader.h

=== debian/changelog ===
odc (1.3.0-1build1) impish; urgency=medium

  * Rebuild against new glibc 2.34.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 18 Aug 2021 13:11:27 +0200

odc (1.3.0-1) unstable; urgency=medium

  * New upstream release
  * Add versioned B-D on libeckit-dev to >= 1.16.0

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 26 Mar 2021 16:01:11 +0000

=== debian/control ===
--- 
+++ 
@@ -6,7 +6,7 @@
  dh-sequence-fortran-mod,
  ecbuild (>= 3.3.0-3),
  gfortran | fortran-compiler, 
- libeckit-dev,
+ libeckit-dev (>= 1.16.0-1~),
  patchelf
 Standards-Version: 4.5.1
 Homepage: https://github.com/ecmwf/odc

## odc 1.4.4

=== CMakeLists.txt ===
--- 
+++ 
@@ -18,14 +18,59 @@
 set(CMAKE_CXX_STANDARD_REQUIRED ON)
 
 ########################################################################################################################
+### sanity checks
+
+### long and double must be 64 bits exactly
+
+# test by c compilation
+ecbuild_check_c_source_return(
+    "#include <stdio.h>\nint main(){printf(\"%ld\",sizeof(long));return 0;}"
+    VAR check_long_final
+    OUTPUT __sizeof_long_final
+)
+ecbuild_check_c_source_return(
+    "#include <stdio.h>\nint main(){printf(\"%ld\",sizeof(double));return 0;}"
+    VAR check_double_final
+    OUTPUT __sizeof_double_final
+)
+
+if( NOT check_long_final OR NOT __sizeof_long_final EQUAL "8" )
+    message( FATAL_ERROR "operating system ${CMAKE_SYSTEM} (${EC_OS_BITS} bits) and sizeof long [${__sizeof_long_final}] -- long must be 64 bits exactly" )
+elseif( NOT check_double_final OR NOT __sizeof_double_final EQUAL "8" )
+    message( FATAL_ERROR "operating system ${CMAKE_SYSTEM} (${EC_OS_BITS} bits) and sizeof double [${__sizeof_double_final}] -- double must be 64 bits exactly" )
+endif()
+
+# test by cxx compilation
+ecbuild_check_cxx_source_return(
+    "#include <iostream>\nint main(){ std::cout << sizeof(long);return 0;}"
+    VAR cxx_check_long_final
+    OUTPUT __cxx_sizeof_long_final
+)
+ecbuild_check_cxx_source_return(
+    "#include <iostream>\nint main(){ std::cout << sizeof(double);return 0;}"
+    VAR cxx_check_double_final
+    OUTPUT __cxx_sizeof_double_final
+)
+
+if( NOT cxx_check_long_final OR NOT __cxx_sizeof_long_final EQUAL "8" )
+    message( FATAL_ERROR "operating system ${CMAKE_SYSTEM} (${EC_OS_BITS} bits) and sizeof long [${__cxx_sizeof_long_final}] -- long must be 64 bits exactly" )
+elseif( NOT cxx_check_double_final OR NOT __cxx_sizeof_double_final EQUAL "8" )
+    message( FATAL_ERROR "operating system ${CMAKE_SYSTEM} (${EC_OS_BITS} bits) and sizeof double [${__cxx_sizeof_double_final}] -- double must be 64 bits exactly" )
+endif()
+
+check_type_size( long ODC_SIZEOF_LONG )
+check_type_size( double ODC_SIZEOF_DOUBLE )
+
+if( NOT ODC_SIZEOF_LONG EQUAL "8" )
+    message( FATAL_ERROR "operating system ${CMAKE_SYSTEM} (${EC_OS_BITS} bits) and sizeof long [${ODC_SIZEOF_LONG}] -- long must be 64 bits exactly" )
+elseif( NOT ODC_SIZEOF_LONG EQUAL "8" )
+    message( FATAL_ERROR "operating system ${CMAKE_SYSTEM} (${EC_OS_BITS} bits) and sizeof double [${ODC_SIZEOF_LONG}] -- double must be 64 bits exactly" )
+endif()
+
+########################################################################################################################
 ### dependencies and options
 
 ecbuild_find_package( NAME eckit VERSION 1.4 REQUIRED )
-
-#ecbuild_add_option( FEATURE NETCDF
-#                    DESCRIPTION "whether or not to build the odb2netcdf tool"
-#                    DEFAULT OFF
-#                    REQUIRED_PACKAGES "NetCDF COMPONENTS CXX" )
 
 ecbuild_add_option( FEATURE FORTRAN
                     DESCRIPTION "whether or not to build the Fortran interface"

=== docs/requirements.txt ===
sphinx==3.5.4
sphinx-rtd-theme==0.5.2
sphinx-copybutton==0.3.1
sphinx-tabs==2.1.0
breathe==4.29.0
sphinx-fortran==1.1.1

=== debian/changelog ===
odc (1.4.4-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 08 Dec 2021 13:38:08 +0000

odc (1.4.2-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 27 Oct 2021 08:44:51 +0100

odc (1.4.1-2) unstable; urgency=medium

  * Build on 64-bit only as we depend on eckit which is now 64-bit only

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 11 Oct 2021 09:57:30 +0100

odc (1.4.1-1) unstable; urgency=medium

  * New upstream release
  * Standards-Version: 4.6.0
  * Now ship more fortran .mod files

 -- Alastair McKinstry <mckinstry@debian.org>  Sun, 29 Aug 2021 17:36:26 +0100

=== debian/control ===
--- 
+++ 
@@ -8,15 +8,15 @@
  gfortran | fortran-compiler, 
  libeckit-dev (>= 1.16.0-1~),
  patchelf
-Standards-Version: 4.5.1
+Standards-Version: 4.6.0
 Homepage: https://github.com/ecmwf/odc
 Vcs-Browser: https://salsa.debian.org:/science-team/odc.git
 Vcs-Git: https://salsa.debian.org:/science-team/odc.git -b debian/latest
 
 Package: libodc-0d
 Section: libs
-Architecture: any
 Multi-Arch: same
+Architecture: amd64 arm64 ppc64 mips64el ppc64el s390x riscv64 sparc64  kfreebsd-amd64 ia64 alpha
 Depends: ${misc:Depends}, ${shlibs:Depends}
 Description: Observational Database Access library for ECMWF
  ODC is software developed at ECMWF for encoding and processing of
@@ -24,7 +24,7 @@
  command line tools and APIs for C/C++ and Fortran.
 
 Package: odc
-Architecture: any
+Architecture: amd64 arm64 ppc64 mips64el ppc64el s390x riscv64 sparc64  kfreebsd-amd64 ia64 alpha
 Multi-Arch: foreign
 Depends: libodc-0d ( = ${binary:Version}), 
   ${shlibs:Depends}, ${misc:Depends}
@@ -38,7 +38,7 @@
 
 Package: libodc-dev
 Section: libdevel
-Architecture: any
+Architecture: amd64 arm64 ppc64 mips64el ppc64el s390x riscv64 sparc64  kfreebsd-amd64 ia64 alpha
 Multi-Arch: same
 Depends: libodc-0d (= ${binary:Version}), odc (= ${binary:Version}), 
   ${misc:Depends}, mpi-default-dev, libeckit-dev

## odc 1.4.5

=== debian/changelog ===
odc (1.4.5-1) unstable; urgency=medium

  * New upstream release
  * Add initial bash completions

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 19 May 2022 19:15:27 +0100

## odc 1.4.6

=== CMakeLists.txt ===
--- 
+++ 
@@ -83,6 +83,8 @@
 ########################################################################################################################
 # contents
 
+include(cmake/compiler_warnings.cmake) # optionally handle compiler specific warnings
+
 add_subdirectory( src )
 add_subdirectory( regressions )
 add_subdirectory( tests )

=== tests/api/CMakeLists.txt ===
--- 
+++ 
@@ -10,5 +10,45 @@
         SOURCES      ${_test}.cc
         ENVIRONMENT  ${test_environment}
         TEST_DEPENDS odc_get_test_data
-        LIBS         eckit odccore )
+        LIBS         eckit odccore odctools )
 endforeach()
+
+list( APPEND _api_odc_example_sources
+    odc_encode_custom
+    odc_header
+    odc_index
+    odc_ls
+)
+
+list( APPEND _api_odc_example_targets
+    odc-cpp-encode-custom
+    odc-cpp-header
+    odc-cpp-index
+    odc-cpp-ls
+)
+
+list( LENGTH _api_odc_example_sources _count )
+math( EXPR _count "${_count}-1" )
+
+foreach( _i RANGE ${_count} )
+    list( GET _api_odc_example_sources ${_i} _sources )
+    list( GET _api_odc_example_targets ${_i} _target )
+
+    ecbuild_add_executable( TARGET     ${_target}
+                            SOURCES    ${_sources}.cc
+                            LIBS       eckit odccore
+                            NOINSTALL )
+endforeach()
+
+list( APPEND _api_odc_tests_scripts
+    usage_examples.sh
+)
+
+foreach( _script ${_api_odc_tests_scripts} )
+    ecbuild_add_test(
+        TARGET odc_api_${_script}
+        TYPE script
+        COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/${_script}
+        ENVIRONMENT PATH=${CMAKE_BINARY_DIR}/bin:$ENV{PATH}
+    )
+endforeach()

=== debian/changelog ===
odc (1.4.6-5) unstable; urgency=medium

  * Rebuild against dh-fortran-mod for gfortran-13

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 20 Jun 2023 13:33:50 +0100

odc (1.4.6-4) unstable; urgency=medium

  * Standards-Version:  4.6.2
  * Fix for FTBFS with g++ 13. Closes: #1037796

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 15 Jun 2023 19:23:43 +0100

odc (1.4.6-3) experimental; urgency=medium

  * Re-enable tests

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 18 Jan 2023 15:28:48 +0000

odc (1.4.6-2) unstable; urgency=medium

  * Rebuild with dh-fortran-mod 0.27. Closes: #1017708

 -- Alastair McKinstry <mckinstry@debian.org>  Sat, 17 Sep 2022 11:19:56 +0100

odc (1.4.6-1) unstable; urgency=medium

  * New upstream release
  * Standards-Version: 4.6.1

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 26 Aug 2022 11:02:52 +0100

=== debian/control ===
--- 
+++ 
@@ -8,7 +8,7 @@
  gfortran | fortran-compiler, 
  libeckit-dev (>= 1.16.0-1~),
  patchelf
-Standards-Version: 4.6.0
+Standards-Version: 4.6.2
 Homepage: https://github.com/ecmwf/odc
 Vcs-Browser: https://salsa.debian.org:/science-team/odc.git
 Vcs-Git: https://salsa.debian.org:/science-team/odc.git -b debian/latest

=== debian/rules ===
--- 
+++ 
@@ -14,6 +14,8 @@
 
 FORTRAN_VERSION:=$(shell basename $(shell readlink  /usr/bin/$(FC)))
 
+DO_TEST:=true
+
 # The magic debhelper  rule
 %:
 	dh $@ --buildsystem=ecbuild
@@ -26,8 +28,7 @@
 		      ${BUILD_FLAGS} -DCMAKE_Fortran_COMPILER=$(FC)
 
 override_dh_auto_test:
-	@echo "Ignoring test failures in this build"
-	# dh_auto_test ||  echo "Ignoring test failures" 
+	$(DO_TEST) && ( LD_LIBRARY_PATH=$(CURDIR)/debian/build/lib dh_auto_test  ) || true
 
 override_dh_dwz:
 	@echo bypass dwz that causes build failures due to patchelf changes
